SystemOrganization addCategory: #'Seaside-Slime'!

!ParseTreeEnvironment methodsFor: '*seaside-slime' stamp: 'lr 12/17/2007 10:48'!
matcher
	^ matcher ifNil: [ matcher := ParseTreeSearcher new ]! !

Object subclass: #WASlime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Slime'!

WASlime class
	instanceVariableNames: 'deprecatedClasses forbiddenRenderingSelectors braceSelectors notPortableSelectors superSelectors notPortableClasses brushSelectors callbackSelectors attributeSelectors forbiddenCallbackSelectors'!

WASlime class
	instanceVariableNames: 'deprecatedClasses forbiddenRenderingSelectors braceSelectors notPortableSelectors superSelectors notPortableClasses brushSelectors callbackSelectors attributeSelectors forbiddenCallbackSelectors'!

!WASlime class methodsFor: 'accessing' stamp: 'lr 1/25/2008 23:35'!
attributeSelectors
	^ attributeSelectors! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 1/25/2008 21:42'!
braceSelectors
	^ braceSelectors! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 1/25/2008 23:21'!
brushSelectors
	^ brushSelectors! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 1/25/2008 23:21'!
callbackSelectors
	^ callbackSelectors! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:49'!
deprecatedClasses
	^ deprecatedClasses! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 7/15/2008 21:44'!
forbiddenCallbackSelectors
	^ forbiddenCallbackSelectors! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 7/15/2008 21:44'!
forbiddenRenderingSelectors
	^ forbiddenRenderingSelectors! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 12/30/2008 19:20'!
initialize
	self initializeAttributeSelectors.
	self initializeBraceSelectors.
	self initializeBrushSelectors.
	self initializeDeprecatedClasses.
	self initializeCallbackSelectors.
	self initializeForbiddenCallbackSelectors.
	self initializeForbiddenRenderingSelectors.
	self initializeNotPortableSelectors.
	self initializeNotPortableClasses.
	self initializeSuperSelectors! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 1/25/2008 23:49'!
initializeAttributeSelectors
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher
		matchesAnyOf: #(
			'self addClass: `@value'
			'self addStyle: `@value'
			'self attributeAt: `@key put: `@value'
			'self attributeAt: `@key ifAbsentPut: `@block'
			'self attributes at: `@key put: `@value'
			'self attributes at: `@key ifAbsentPut: `@block'
			'self attributes at: `@key append: `@value'
			'self attributes at: `@key append: `@value separator: `@separator' )
		do: [ :context :node | true ].
	attributeSelectors := Set new.
	WABrush allSubclassesDo: [ :class | 
		class methodDictionary keysAndValuesDo: [ :selector :method | 
			(matcher executeTree: method parseTree initialAnswer: false) 
				ifTrue: [ attributeSelectors add: selector ] ] ].
	#( callback: enabled: labels: value: )
		do: [ :each | attributeSelectors add: each ]! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 1/25/2008 21:42'!
initializeBraceSelectors
	braceSelectors := #( braceStream: braceWith: braceWith:with: braceWith:with:with: braceWith:with:with:with: braceWithNone ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 1/25/2008 23:22'!
initializeBrushSelectors
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher
		matchesAnyMethodOf: #(
			'`selector ^ self tag: `#tag'
			'`selector ^ self brush: `@obj'
			'`selector: `aBlock self `selector with: `aBlock'
			'`selector ^ `class on: self' )
		do: [ :context :node | true ].
	brushSelectors := Set new.
	WACanvas allSubclassesDo: [ :class | 
		class methodDictionary keysAndValuesDo: [ :selector :method | 
			(matcher executeTree: method parseTree initialAnswer: false) 
				ifTrue: [ brushSelectors add: selector ] ] ]! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 1/25/2008 23:38'!
initializeCallbackSelectors
	callbackSelectors := #( callback: callback:value: defaultAction: triggerArgument:callback: triggerAutocompleter: triggerInPlaceEditor: triggerPassenger: triggerSliderCallback: triggerSortable:callback: triggerTree:callback: ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 7/15/2008 23:57'!
initializeDeprecatedClasses
	deprecatedClasses := #( WAStandardScripts WAStandardStyles WAModelProxy WAStateHolder ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 7/15/2008 21:44'!
initializeForbiddenCallbackSelectors
	forbiddenCallbackSelectors := #( addLoadScript: ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 7/15/2008 21:43'!
initializeForbiddenRenderingSelectors
	forbiddenRenderingSelectors := #( answer answer: call: show: show:onAnswer: show:onAnswer:delegation: lightbox: chooseFrom: chooseFrom:caption: confirm: inform: request: request:default: request:label: request:label:default: ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'pmm 12/6/2008 09:38'!
initializeNotPortableClasses
	notPortableClasses := #( Semaphore MIMEDocument Random TimeStamp ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'pmm 1/10/2009 14:53'!
initializeNotPortableSelectors
	notPortableSelectors :=  #( and:and: and:and:and: and:and:and:and: collect:thenDo: collect:thenSelect: doIfNotNil: fixTemps ifNil:ifNotNil: ifNil:ifNotNilDo: ifNotNil: ifNotNil:ifNil: ifNotNilDo: ifNotNilDo:ifNil: match: or:or:or: or:or:or:or: or:or:or:or:or: pairsDo: reject:thenDo: select:thenCollect: select:thenDo: raiseSignal raiseSignal: with:collect: ) asSet! !

!WASlime class methodsFor: 'initialization' stamp: 'lr 11/11/2008 22:32'!
initializeSuperSelectors
	superSelectors := Dictionary new.
	superSelectors
		at: WAObject name put: #(initialize postCopy) asSet;
		at: WAPainter name put: #(updateRoot: updateUrl:) asSet;
		at: WATagBrush name put: #(setParent:canvas: with: before after openTag closeTag) asSet;
		at: WARequestFilter name put: #(responseForContext:) asSet! !

!WASlime class methodsFor: 'testing' stamp: 'lr 7/15/2008 21:41'!
isBrushSelector: aString
	Symbol 
		hasInterned: aString
		ifTrue: [ :symbol | ^ brushSelectors includes: symbol ].
	^ false! !

!WASlime class methodsFor: 'testing' stamp: 'lr 7/15/2008 21:41'!
isCallbackSelector: aString 
	Symbol 
		hasInterned: aString
		ifTrue: [ :symbol | ^ callbackSelectors includes: symbol ].
	^ false! !

!WASlime class methodsFor: 'testing' stamp: 'lr 7/15/2008 23:49'!
isWithinCallback: aNode
	| parent |
	parent := aNode parent 
		ifNil: [ ^ false ].
	(aNode isBlock and: [ parent isMessage and: [ callbackSelectors includes: parent selector ] ])
		ifTrue: [ ^ true ].
	^ self isWithinCallback: parent! !

!WASlime class methodsFor: 'accessing' stamp: 'AvO 12/2/2008 19:37'!
notPortableClasses
	^ notPortableClasses! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 1/25/2008 21:08'!
notPortableSelectors
	^ notPortableSelectors! !

!WASlime class methodsFor: 'accessing' stamp: 'lr 12/17/2007 15:57'!
superSelectors
	^ superSelectors! !

!WAPackage class methodsFor: '*seaside-slime' stamp: 'lr 12/18/2008 20:28'!
seasideSlime
	^ self new
		name: 'Seaside-Slime';
		description: 'Code critis for Seaside. Detects common types of bugs.';
		addDependency: 'Seaside-Component';
		addDependency: 'Seaside-Session';
		yourself! !

TransformationRule subclass: #WASlimeTransformationRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Slime'!

!WASlimeTransformationRule class methodsFor: 'transformations' stamp: 'lr 1/17/2009 10:24'!
ansiCompatibilityBooleans
	^ self
		rewrite: #(
			" #and: "
			('``@expr1 and: [ | `@temp2 | ``@expr2 ] and: [ | `@temp3 | ``@expr3 ]'
			 '``@expr1 and: [ | `@temp2 | ``@expr2 and: [ | `@temp3 | ``@expr3 ] ]')
			('``@expr1 and: [ | `@temp2 | ``@expr2 ] and: [ | `@temp3 | ``@expr3 ] and: [ | `@temp4 | ``@expr4 ]'
			 '``@expr1 and: [ | `@temp2 | ``@expr2 and: [ | `@temp3 | ``@expr3 and: [ | `@temp4 | ``@expr4 ] ] ]')
			('``@expr1 and: [ | `@temp2 | ``@expr2 ] and: [ | `@temp3 | ``@expr3 ] and: [ | `@temp4 | ``@expr4 ] and: [  | `@temp5 | ``@expr5 ]'
			 '``@expr1 and: [ | `@temp2 | ``@expr2 and: [ | `@temp3 | ``@expr3 and: [ | `@temp4 | ``@expr4 and: [ | `@temp5 | ``@expr5 ] ] ] ]')
			" #or: "
			('``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ]'
			 '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 ] ]')
			('``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ] or: [ | `@temp4 | ``@expr4 ]'
			 '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 or: [ | `@temp4 | ``@expr4 ] ] ]')
			('``@expr1 or: [ | `@temp2 | ``@expr2 ] or: [ | `@temp3 | ``@expr3 ] or: [ | `@temp4 | ``@expr4 ] or: [  | `@temp5 | ``@expr5 ]'
			 '``@expr1 or: [ | `@temp2 | ``@expr2 or: [ | `@temp3 | ``@expr3 or: [ | `@temp4 | ``@expr4 or: [ | `@temp5 | ``@expr5 ] ] ] ]'))
		methods: false
		name: 'ANSI Compatibility: Booleans'! !

!WASlimeTransformationRule class methodsFor: 'transformations' stamp: 'lr 1/17/2009 10:42'!
ansiCompatibilityCollections
	^ self
		rewrite: #(
			('``@collection withIndexDo: [ :`each :`index |  | `@temps | ``@body ]'
			 '``@collection keysAndValuesDo: [ :`index :`each |  | `@temps | ``@body ]')
			('``@collection doWithIndex: [ :`each :`index |  | `@temps | ``@body ]'
			 '``@collection keysAndValuesDo: [ :`index :`each |  | `@temps | ``@body ]')
			('``@collection collect: ``@block1 thenDo: ``@block2'
			 '(``@collection collect: ``@block1) do: ``@block2')
			('``@collection collect: ``@block1 thenSelect: ``@block2'
			 '(``@collection collect: ``@block1) select: ``@block2')
			('``@collection pairsDo: [ :`t1 :`t2 | ``@statements ]'
			 '1 to: ``@collection size by: 2 do:  [ :index | | `t1 `t2 | t1 := ``@collection at: index. t2 := ``@collection at: index + 1. ``@statements ]')
			('``@collection reject: ``@block1 thenDo: ``@block2'
			 '(``@collection reject: ``@block1) do: ``@block2')
			('``@collection select: ``@block1 thenCollect: ``@block2'
			 '(``@collection select: ``@block1) collect: ``@block2')
			('``@collection select: ``@block1 thenDo: ``@block2'
			 '(``@collection select: ``@block1) do: ``@block2'))			
		methods: false
		name: 'ANSI Compatibility: Collections'! !

!WASlimeTransformationRule class methodsFor: 'transformations' stamp: 'lr 1/17/2009 12:49'!
ansiCompatibilityConditionals
	^ self
		rewrite: #(
			" kill abnormalities "
			('``@boolean ifNotNilDo: ``@block'
			 '``@boolean ifNotNil: ``@block')
			('``@boolean ifNotNilDo: ``@block1 ifNil: ``@block2'
			 '``@boolean ifNotNil: ``@block1 ifNil: ``@block2')
			('``@boolean ifNil: ``@block1 ifNotNilDo: ``@block2'
			 '``@boolean ifNil: ``@block1 ifNotNil: ``@block2')
			" normalize arguments "
			('``@boolean ifNotNil: [ | `@temps | ``@body ]'
			 '``@boolean ifNotNil: [ :arg | | `@temps | ``@body ]')
			('``@boolean ifNotNil: [ | `@temps | ``@body ] ifNil: ``@block '
			 '``@boolean ifNotNil: [ :arg | | `@temps | ``@body ] ifNil: ``@block')
			('``@boolean ifNil: ``@block ifNotNil: [ | `@temps | ``@body ]'
			 '``@boolean ifNil: ``@block ifNotNil: [ :arg | | `@temps | ``@body ]'))
		methods: false
		name: 'ANSI Compatibility: Conditionals'! !

!WASlimeTransformationRule class methodsFor: 'transformations' stamp: 'lr 1/17/2009 12:49'!
ansiCompatibilityExceptions
	^ self
		rewrite: #(
			('``@block on: `class do: [ | `@temps | ``@body ]'
			 '``@block on: `class do: [ :err |  | `@temps | ``@body ]'))
		methods: false
		name: 'ANSI Compatibility: Exceptions'! !

!WASlimeTransformationRule class methodsFor: 'transformations' stamp: 'lr 1/11/2009 22:16'!
handleRequest
	| rewriteRule |
	rewriteRule := ParseTreeRewriter new
		replaceMethod: 'handleRequest: `aRequest | `@temps | `@.statements' withValueFrom: [ :node |
			ParseTreeRewriter new
				replace: node arguments first name with: 'aRequestContext';
				executeTree: node.
			ParseTreeRewriter new
				replace: 'aRequestContext' with: 'aRequestContext request';
				executeTree: node body.
			node
				selector: #handleFiltered:;
				arguments: (Array with: (RBVariableNode named: 'aRequestContext'));
				yourself ].
	^ self new
		name: 'Rename WARequestHandler>>#handleRequest: to #handleFiltered:';
		rewriteUsing: rewriteRule;
		yourself! !

!WASlimeTransformationRule class methodsFor: 'transformations' stamp: 'lr 1/11/2009 22:16'!
sessionExpired
	^self
		rewrite: #(
			#('expired 
					| `@temps | 
					`@.Statements'
			"->"
			'unregistered
					| `@temps | 
					`@.Statements'))
		methods: true
		name: 'Rename WASession>>#expired to #unregistered'! !

BlockLintRule subclass: #WASlimeBlockLintRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Slime'!

!WASlimeBlockLintRule class methodsFor: 'seaside-portability' stamp: 'lr 1/7/2009 11:38'!
basicNewInitializeMissing
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matches: 'self basicNew initialize'
		do: [ :node :answer | true ].
	^ self new
		name: '#basicNew initialize is missing';
		rationale: '#initialize is not called implicitely when sending #new to an object in other Smalltalk dialects.';
		classBlock: [ :context :result |
			(context selectedClass isMeta not
				and: [ (context selectedClass includesSelector: #initialize)
				and: [ (context selectedClass includesBehavior: WAObject) not
				and: [
					context selectedClass class methodDict noneSatisfy: [ :each | 
						matcher 
							executeTree: each parseTree 
							initialAnswer: false ] ] ] ])
				ifTrue: [ result addClass: context selectedClass selector: #initialize ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
changesStateWhileRendering
	| matcher matches |
	matcher := ParseTreeSearcher new.
	matcher 
		matches: '`var'
		do: 
			[ :node :answer | 
			(node isWrite and: [ (WASlime isWithinCallback: node) not ]) ifTrue: [ answer add: node ].
			answer ].
	^ self new
		name: 'Changes state while rendering';
		rationale: 'Application state should not be changed in the rendering code, use a callback to define state.';
		resultClass: ParseTreeEnvironment;
		methodBlock: 
			[ :context :result | 
			| vars |
			context isRenderingMethod ifTrue: 
				[ matches := matcher 
					executeTree: context parseTree
					initialAnswer: OrderedCollection new.
				matches isEmpty ifFalse: 
					[ vars := context instVarNames.
					matches do: 
						[ :each | 
						(vars includes: each name) ifTrue: 
							[ result 
								addClass: context selectedClass
								selector: context selector.
							result matcher 
								matches: each name , ' := ``@obj'
								do: 
									[ :node :answer | 
									answer isNil 
										ifTrue: [ node ]
										ifFalse: [ answer ] ] ] ] ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'lr 12/30/2008 12:42'!
deprecatedApiProtocol
	| matcher matches |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: #(
			'``@receiver seasideDeprecatedApi: ``@arg1'
			'``@receiver seasideDeprecatedApi: ``@arg1 details: ``@arg2' )
		do: [ :node :answer | answer add: node; yourself ].
	^ self new
		name: 'Invalid use of deprecated API protocol.';
		rationale: 'Make sure to follow the following pattern: self seasideDeprecatedApi: ''Class>>#selector'' details: ''Some description.''';
		methodBlock: [ :context :result |
			matches := matcher executeTree: context parseTree initialAnswer: OrderedCollection new.
			matches do: [ :node |
				(node arguments first isLiteral and: [ node arguments first value isString and: [ context selectedClass name asString , '>>#' , context selector asString ~= node arguments first value ] ]) ifTrue: [
					result addClass: context selectedClass selector: context selector.
					result addSearchString: node arguments first value ].
				(node arguments size > 1 and: [ node arguments second isLiteral and: [ node arguments second value isString and: [ (node arguments second value endsWith: '.') not ] ] ]) ifTrue: [
					result addClass: context selectedClass selector: context selector.
					result addSearchString: node arguments second value ] ] ];
		yourself! !

!WASlimeBlockLintRule class methodsFor: 'seaside-portability' stamp: 'pmm 12/6/2008 23:36'!
directlySubclassObject
	^ self new
		resultClass: ClassEnvironment;
		name: 'Directly subclasses Object';
		rationale: 'Smalltalk dialects initialize objects differently, consider subclassing from WAObject to get a consistent initialization behavior.';
		classBlock: [ :context :result |
			| selectedClass |
			selectedClass := context selectedClass.
			(selectedClass superclass = Object and: [ selectedClass ~= WAObject ])
				ifTrue: [ result addClass: selectedClass ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
doNotUseWhileRendering
	| matcher matches |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: (WASlime forbiddenRenderingSelectors collect: [ :each | 'self' , (ParseTreeLintRule genericPatternForSelector: each) ])
		do: 
			[ :node :answer | 
			(WASlime isWithinCallback: node) ifFalse: [ answer add: node ].
			answer ].
	^ self new
		name: 'Do not use while rendering';
		rationale: 'Certain functionaly should not be used while rendering. For example: #call: and #answer: should only be used from within callback code.';
		methodBlock: 
			[ :context :result | 
			context isRenderingMethod ifTrue: 
				[ matches := matcher 
					executeTree: context parseTree
					initialAnswer: OrderedCollection new.
				matches do: 
					[ :each | 
					result 
						addClass: context selectedClass
						selector: context selector.
					result addSearchString: each selector ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
doNotUseWithinCallback
	| matcher matches |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: (WASlime forbiddenCallbackSelectors collect: [ :each | '``@receiver' , (ParseTreeLintRule genericPatternForSelector: each) ])
		do: 
			[ :node :answer | 
			(WASlime isWithinCallback: node) ifTrue: [ answer add: node ].
			answer ].
	^ self new
		name: 'Do not use within callback';
		rationale: 'Certain functionaly should not be used within callbacks. For example: #addLoadScript: should only be used while rendering.';
		methodBlock: 
			[ :context :result | 
			context isRenderingMethod ifTrue: 
				[ matches := matcher 
					executeTree: context parseTree
					initialAnswer: OrderedCollection new.
				matches do: 
					[ :each | 
					result 
						addClass: context selectedClass
						selector: context selector.
					result addSearchString: each selector ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'pmm 10/18/2008 20:45'!
implementsSessionExpired
	^ self new
		name: 'Implements #expired in a session class';
		rationale: 'The message #expired has been replaced by #unregistered';
		methodBlock: [ :context :result |
			| class selectors |
			class := context selectedClass.
			((class inheritsFrom: WASession)
				and: [ class includesSelector: #expired ])
					ifTrue: [ result addClass: class selector: context selector ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
instantiatesComponentWhileRendering
	| matcher matches class |
	matcher := ParseTreeSearcher new.
	matcher 
		matches: '``@receiver `@message: ``@args'
		do: 
			[ :node :answer | 
			(node receiver isVariable and: 
				[ (class := Smalltalk classNamed: node receiver name) notNil and: 
					[ class isBehavior and: 
						[ (class includesBehavior: WAPresenter) and: [ (WASlime isWithinCallback: node) not ] ] ] ]) ifTrue: [ answer add: node ].
			answer ].
	^ self new
		name: 'Instantiates component while rendering';
		rationale: 'Components should only be instanciated in initialization-code, callbacks or through lazy initialization.';
		methodBlock: 
			[ :context :result | 
			context isRenderingMethod ifTrue: 
				[ matches := matcher 
					executeTree: context parseTree
					initialAnswer: OrderedCollection new.
				matches do: 
					[ :each | 
					result 
						addClass: context selectedClass
						selector: context selector.
					result addSearchString: each receiver name ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside-portability' stamp: 'lr 1/7/2009 12:11'!
invalidObjectInitialization
	^ self new
		name: 'Invalid object initialization';
		rationale: 'Initialize methods are required to call the designated initializer or its super implementation.';
		methodBlock: [ :context :result |
			(context selectedClass isMeta not
				and: [ ((context selector = #initialize) 
					or: [ (context selector beginsWith: #initialize) 
					and: [ context selector numArgs > 0 ] ])
				and: [ (context selectedClass ~= WAObject)
				and: [ (context selectedClass includesBehavior: WAObject)
				and: [ (context superMessages includes: context selector) not
				and: [ (context selfMessages noneSatisfy: [ :each | each beginsWith: #initialize ]) ] ] ] ] ])
					ifTrue: [ result addClass: context selectedClass selector: context selector ] ]! !

!WASlimeBlockLintRule class methodsFor: 'accessing' stamp: 'lr 1/11/2009 22:27'!
protocols
	^ #('seaside' 'seaside-portability')! !

!WASlimeBlockLintRule class methodsFor: 'seaside-portability' stamp: 'lr 1/11/2009 22:10'!
usesCurlyBraceArrays
	^ self new
		name: 'Uses curly brace arrays';
		rationale: 'Curly brace expressions are not portable accross different Smalltalk dialects.';
		methodBlock: 
			[ :context :result | 
			context compiledMethod literals do: 
				[ :each | 
				(each isSymbol and: [ WASlime braceSelectors includes: each ]) ifTrue: 
					[ result 
						addClass: context selectedClass
						selector: context selector.
					result addSearchString: '{' ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
usesDeprecatedClass
	^ self new
		name: 'Uses deprecated class';
		rationale: 'Deprecated classes will be removed with the next release of Seaside.';
		classBlock: 
			[ :context :result | 
			(context selectedClass allSuperclasses anySatisfy: [ :each | WASlime deprecatedClasses includes: each name ]) ifTrue: [ result addClass: context selectedClass ] ];
		methodBlock: 
			[ :context :result | 
			context compiledMethod literals do: 
				[ :each | 
				(each isVariableBinding and: [ WASlime deprecatedClasses includes: each key ]) ifTrue: 
					[ result 
						addClass: context selectedClass
						selector: context selector.
					result addSearchString: each key ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside-portability' stamp: 'lr 2/21/2008 10:19'!
usesLiteralByteArrays
	^ self new
		name: 'Uses literal byte arrays';
		rationale: 'Literal byte arrays are not portable accross different Smalltalk dialects.';
		methodBlock: [ :context :result |
			context compiledMethod literals do: [ :each |
				(each isLiteral and: [ each isKindOf: ByteArray ]) ifTrue: [ 
					result addClass: context selectedClass selector: context selector.
					result addSearchString: '#[' ] ] ]! !

!WASlimeBlockLintRule class methodsFor: 'seaside-portability' stamp: 'lr 1/11/2009 23:48'!
usesNotPortableClass
	^ self new
		name: 'Uses not portable class';
		rationale: 'Some classes are not portable accross different Smalltalk dialects.';
		classBlock: 
			[ :context :result | 
			(context selectedClass allSuperclasses anySatisfy: [ :each | WASlime notPortableClasses includes: each name ]) ifTrue: 
				[ result addClass: context selectedClass.
				result addSearchString: context selectedClass superclass name ] ];
		methodBlock: 
			[ :context :result | 
			context compiledMethod literals do: 
				[ :each | 
				(each isVariableBinding and: [ WASlime notPortableClasses includes: each key ]) ifTrue: 
					[ result 
						addClass: context selectedClass
						selector: context selector.
					result addSearchString: each key ] ] ]! !

ParseTreeLintRule subclass: #WASlimeParseTreeLintRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Slime'!

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
avoidUnnecessaryWith
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matches: '`html `msg with: ``@arg'
		do: 
			[ :node :answer | 
			(answer isNil and: 
				[ node parent isCascade not and: 
					[ (WASlime isBrushSelector: node receiver selector) and: 
						[ (WASlime isBrushSelector: node receiver selector , ':') and: [ (WASlime isBrushSelector: node methodNode selector) not ] ] ] ]) ifTrue: [ node ] ].
	^ self new
		name: 'Avoid unnecessary #with:';
		rationale: 'Sending #with: is only required if attributes are specified too.';
		matcher: matcher;
		yourself! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
extractCallbackCodeToMethod
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: (WASlime callbackSelectors collect: [ :each | '`html `msg' , (self genericPatternForSelector: each) ])
		do: 
			[ :node :answer | 
			(answer isNil and: [ WASlime isBrushSelector: node receiver selector ]) ifTrue: 
				[ node arguments 
					detect: [ :each | each isBlock and: [ each body statements size > 1 ] ]
					ifNone: [ nil ] ] ].
	^ self new
		name: 'Extract callback code to separate method';
		rationale: 'For clarity rendering code and callback code should not be mixed, extract the contents of the callback block to a separate method.';
		matcher: matcher;
		yourself! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
fixCallbackTempsMissing
	| saveSelectors matcher |
	saveSelectors := #(
		#allSatisfy:
		#anySatisfy:
		#at:ifAbsent:
		#at:ifAbsentPut:
		#at:ifPresent:
		#count:
		#critical:
		#detect:ifNone:
		#do:
		#do:separatedBy:
		#ensure:
		#fixCallbackTemps
		#fixTemps
		#ifCurtailed:
		#inject:into:
		#noneSatisfy:
		#on:do:
		#reject:
		#render:
		#select:
		#should:
		#should:description:
		#should:raise:
		#should:raise:description:
		#should:raise:whoseDescriptionDoesNotInclude:description:
		#should:raise:whoseDescriptionIncludes:description:
		#shouldnt:
		#shouldnt:description:
		#shouldnt:raise:
		#shouldnt:raise:description:
		#shouldnt:raise:whoseDescriptionDoesNotInclude:description:
		#shouldnt:raise:whoseDescriptionIncludes:description:
		#timesRepeat:
		#use:during:
		#with:
	) asSet.
	matcher := ParseTreeSearcher new.
	matcher 
		matches: '[ | `@temps | `@.statements ]'
		do: 
			[ :node :answer | 
			| found |
			found := false.
			(answer isNil and: [ node isInlined not and: [ node parent isMessage ] ]) ifTrue: 
				[ ((saveSelectors includes: node parent selector) or: 
					[ (WASlime brushSelectors includes: node parent selector) or: 
						[ (WASlime attributeSelectors includes: node parent selector) or: [ WASlime callbackSelectors includes: node parent selector ] ] ]) ifFalse: 
					[ | dangerousNames |
					dangerousNames := Set new.
					node parent parents do: 
						[ :parent | 
						parent isBlock ifTrue: [ dangerousNames addAll: parent argumentNames ].
						parent isSequence ifTrue: [ dangerousNames addAll: parent temporaryNames ] ].
					(dangerousNames anySatisfy: [ :each | node references: each ]) ifTrue: [ found := true ] ] ].
			found ifTrue: [ node ] ].
	^ self new
		name: '#fixCallbackTemps possibly missing';
		rationale: 'I don''t feel like explaining that here.';
		matcher: matcher;
		yourself! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside-portability' stamp: 'lr 1/17/2009 12:11'!
sendsNotPortableMessage
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: (
			WASlime notPortableSelectors asArray 
				collect: [ :each | '`@object' , (self genericPatternForSelector: each) ]) , 
			#( 'Dictionary withAll: `@args' )
		do: [ :node :answer | node ].
	^ self new
		matcher: matcher;
		name: 'Sends not portable message';
		rationale: 'Some methods are not portable accross different Smalltalk dialects.'! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 7/15/2008 23:34'!
sendsRenderContentOn
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher
		matches: '`@object renderContentOn: `@html'
		do: [ :node :answer |
			(answer isNil
				and: [ (node receiver isVariable and: [ node receiver name = 'super' ]) not
				and: [ (#( render: renderWithContext: ) includes: node methodNode selector) not ] ])
					ifTrue: [ node ] ].
	^ self new
		name: 'Sends #renderContentOn:';
		rationale: 'Client code should never send #renderContentOn: directly but only #render:';
		matcher: matcher;
		yourself! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
unnecessaryBlockPassedToBrush
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: #(
				'`html `msg: [ ]'
				'`html `msg: [ `html text: ``@arg ]'
				'`html `msg: [ `html render: ``@arg ]'
			)
		do: 
			[ :node :answer | 
			(answer isNil and: [ WASlime isBrushSelector: node selector ]) ifTrue: [ node arguments first ] ].
	matcher 
		matchesAnyOf: #(
				'`html `msg with: [ ]'
				'`html `msg with: [ `html text: ``@arg ]'
				'`html `msg with: [ `html render: ``@arg ]'
			)
		do: 
			[ :node :answer | 
			(answer isNil and: [ WASlime isBrushSelector: node receiver selector ]) ifTrue: [ node arguments first ] ].
	^ self new
		name: 'Unnecessary block passed to brush';
		rationale: 'Sending a block as argument to #with: is only needed when nesting brushes.';
		matcher: matcher;
		yourself! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 12/3/2008 12:33'!
usesWrongRenderer
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: #(
			" JQuery: "
			'``@obj ajax html: [ :`r | | `@temps | `@.statements ]'
			'``@obj load html: [ :`r | | `@temps | `@.statements ]'
			'``@obj ajax script: [ :`r | | `@temps | `@.statements ]'
			'``@obj load script: [ :`r | | `@temps | `@.statements ]'
			'``@obj ajax text: [ :`r | | `@temps | `@.statements ]'
			'``@obj load text: [ :`r | | `@temps | `@.statements ]'
			" Scriptaculous: "
			'``@obj updater callback: [ :`r | | `@temps | `@.statements ]'
			'``@obj evaluator callback: [ :`r | | `@temps | `@.statements ]'
			'``@obj periodical callback: [ :`r | | `@temps | `@.statements ]'
			'``@obj autocompleter callback: [ :`r | | `@temps | `@.statements ]'
			'``@obj inPlaceEditor callback: [ :`r | | `@temps | `@.statements ]'
			'``@obj inPlaceCollectionEditor callback: [ :`r | | `@temps | `@.statements ]' )
		do: [ :node :answer | 
			(answer isNil and: [ node arguments first references: node receiver receiver name ])
				ifTrue: [ node arguments first ]
				ifFalse: [ answer ] ].
	^ self new
		name: 'Uses the wrong renderer';
		rationale: 'Within AJAX callbacks you need to use the renderer that is passed into the block, the renderer from the outer context is only valid during the rendering of the outer context.';
		matcher: matcher;
		yourself! !

!WASlimeParseTreeLintRule class methodsFor: 'seaside' stamp: 'lr 1/11/2009 22:10'!
withHasToBeLastMessageInCascade
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher 
		matches: '`html `msg with: ``@arg'
		do: 
			[ :node :answer | 
			(answer isNil and: 
				[ node parent isCascade and: 
					[ (node parent messages last = node) not and: [ WASlime isBrushSelector: node receiver selector ] ] ]) ifTrue: [ node ] ].
	^ self new
		name: '#with: has to be last message in cascade';
		rationale: 'Sending #with: triggers serialization of the brush attributes, any attribute being specified afterwards has no effect.';
		matcher: matcher;
		yourself! !

!RBProgramNode methodsFor: '*seaside-slime' stamp: 'lr 12/17/2007 10:02'!
parents
	^ parent isNil
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [
			parent parents
				addLast: self;
				yourself ]! !

!SmalllintContext methodsFor: '*seaside-slime' stamp: 'lr 1/11/2009 23:43'!
isRenderingMethod
	(self selector numArgs > 0 and: [ self selector beginsWith: #render ])
		ifFalse: [ ^ false ].
	self compiledMethod literals do: [ :each |
		(each isSymbol and: [ WASlime isBrushSelector: each ])
			ifTrue: [ ^ true ] ].
	^ false! !
WASlime initialize!
